blob: 6a61a92c5f9a5b43e6c9d19a21261717cf437e33 [file] [log] [blame]
Sean Condonf6af2a52018-08-19 10:43:24 +01001"""
2 Copyright 2018-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the ONOS GUI 2
19
Sean Condon0c577f62018-11-18 22:40:05 +000020 The GUI2 Angular 7 elements are built here with Angular CLI 'ng'
Sean Condonf6af2a52018-08-19 10:43:24 +010021 Some work is being done in the Bazel community to integrate Bazel and
Sean Condon0c577f62018-11-18 22:40:05 +000022 Angular 7, (Angular Buildtools Convergence -
Sean Condonf6af2a52018-08-19 10:43:24 +010023 https://docs.google.com/document/d/1OlyiUnoTirUj4gecGxJeZBcjHcFr36RvLsvpBl2mxA8/preview)
24 but it is in the very early stages (Aug'18) and not yet fit
25 for production and at present it works as a replacement for Angular CLI
26 (which is not desirable).
27
28 There are plans to extend Bazel it to work with Angular CLI, and if works
29 well this Bazel file may be rearchiteced in future.
30
31 Bazel and npm are incompatibe in how they deal with files. npm likes to
32 follow links to get back to the original canonical path names, and bazel
33 uses links extensively when populating the sandbox. To get around these
34 problems, the rules that follow use filegroups to specify the files as
35 dependencies and then use a genrule to convert the files into a tar ball.
36 Once the tar ball is unrolled into the sandbox, the links are broken, but
37 the build is still hermetic since those files are referred to as dependencies in the genrule.
38"""
39
Carmelo Casconed33d3b42019-06-18 12:12:36 -070040load("//tools/build/bazel:jdk_genrule.bzl", genrule = "jdk_genrule")
41
Sean Condonb2c483c2019-01-16 20:28:55 +000042COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + CLI + [
Sean Condonf6af2a52018-08-19 10:43:24 +010043 "@javax_ws_rs_api//jar",
44 "@servlet_api//jar",
45 "@jetty_websocket//jar",
Sean Condonb2c483c2019-01-16 20:28:55 +000046 "@jetty_websocket_api//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010047 "@jetty_util//jar",
48 "@jersey_media_multipart//jar",
49 "@jersey_server//jar",
Ray Milkey427e9752018-11-15 16:34:48 -080050 "@jersey_hk2//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010051 "//utils/rest:onlab-rest",
52 "//core/store/serializers:onos-core-serializers",
53]
54
55TEST_DEPS = TEST + [
56 "//core/api:onos-api-tests",
57 "//drivers/default:onos-drivers-default",
58]
59
60"""
61 Files that get put at the top level of the tar ball
62"""
63
64filegroup(
65 name = "_root_level_files",
66 srcs =
67 [
68 ":angular.json",
69 ":karma.conf.js",
70 ":package.json",
71 ":package-lock.json",
72 ":protractor.conf.js",
73 ":src/main/tsconfig.json",
74 ":src/main/tslint.json",
75 ":tsconfig.json",
76 ],
77)
78
79filegroup(
80 name = "_e2e_test_files",
81 srcs = [
82 ":e2e/app.e2e-spec.ts",
83 ":e2e/app.po.ts",
84 ":e2e/tsconfig.e2e.json",
85 ],
86)
87
88"""
89 Files that get put into the WEB-INF directory of the tar ball
90"""
91
92filegroup(
93 name = "_web_inf_classes_files",
94 srcs =
95 [
96 ":src/main/webapp/error.html",
97 ":src/main/webapp/login.html",
98 ":src/main/webapp/nav.html",
99 ":src/main/webapp/not-ready.html",
Sean Condon55c30532018-10-29 12:26:57 +0000100 ":src/main/webapp/onos.global.css",
Sean Condonf6af2a52018-08-19 10:43:24 +0100101 ],
102)
103
104"""
Sean Condonf6af2a52018-08-19 10:43:24 +0100105 Run ng build to create outputs in production mode
Sean Condon53d4e832019-10-25 12:27:54 +0100106 See bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-build-prod.log for details of the Angular CLI output
Sean Condon5ca00262018-09-06 17:55:25 +0100107
108 To avoid the overhead of having several "npm install" invocations, we just do
Sean Condon0c577f62018-11-18 22:40:05 +0000109 it once in the //web/gui2-fw-lib which is really the core for the whole Angular 7
Sean Condon5ca00262018-09-06 17:55:25 +0100110 structure in ONOS. This copies files in to node_modules, but because the gui2-fw-lib
111 has not been generated at that time we copy it in separately below with the 'tar' cmd
112 and then 'mv'
Sean Condonf6af2a52018-08-19 10:43:24 +0100113"""
114
115genrule(
116 name = "_onos-gui2-ng-build",
117 srcs = [
118 "@nodejs//:bin/npm",
119 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100120 "@nodejs//:bin/nodejs/bin/node",
121 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100122 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
123 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
124 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonff85fbe2019-03-16 14:28:46 +0000125 "//web/gui2-topo-lib:gui2-topo-lib-build",
Sean Condon87b78502018-09-17 20:53:24 +0100126 "//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build",
Sean Condon5ca00262018-09-06 17:55:25 +0100127 ":_root_level_files",
Sean Condonf6af2a52018-08-19 10:43:24 +0100128 ":_web_app_all",
Boyuan Yan6b23b382019-06-04 11:59:35 -0700129 "//apps/roadm/web/roadm-gui:roadm-gui-lib-build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100130 ],
131 outs = [
132 "onos-gui2-ng-build-prod.log",
133 "onos-gui2-ng-build.jar",
134 ],
135 cmd = "ROOT=`pwd` &&" +
136 " export HOME=. &&" +
137 " export XDG_CONFIG_HOME=$(@D)/config &&" +
138 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100139 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
140 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100141 " mkdir -p web/gui2 && cd web/gui2 &&" +
142 " jar xf ../../$(location :_web_app_all) &&" +
143 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100144 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
145 " mv package/ node_modules/gui2-fw-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100146 # Add in modules from external packages
Sean Condonff85fbe2019-03-16 14:28:46 +0000147 " GUI2_TOPO_LIB_FILES=($(locations //web/gui2-topo-lib:gui2-topo-lib-build)) &&" + # An array of filenames - sorted by time created
148 " tar xf $$ROOT/$${GUI2_TOPO_LIB_FILES[0]} &&" +
149 " mv package/ node_modules/gui2-topo-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100150 " FM_GUI2_LIB_FILES=($(locations //apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build)) &&" + # An array of filenames - sorted by time created
151 " tar xf $$ROOT/$${FM_GUI2_LIB_FILES[0]} &&" +
152 " mv package/ node_modules/fm-gui2-lib/ &&" +
Boyuan Yan6b23b382019-06-04 11:59:35 -0700153 " ROADM_GUI_LIB_FILES=($(locations //apps/roadm/web/roadm-gui:roadm-gui-lib-build)) &&" + # An array of filenames - sorted by time created
154 " tar xf $$ROOT/$${ROADM_GUI_LIB_FILES[0]} &&" +
155 " mv package/ node_modules/roadm-gui-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100156 # End of add in modules from external packages
Sean Condon5ca00262018-09-06 17:55:25 +0100157 " mkdir -p src/main/webapp/app/fw &&" +
158 " (cd src/main/webapp/app/fw &&" +
159 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100160 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700161 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100162 " node -v > ../../$(location onos-gui2-ng-build-prod.log) &&" +
163 " npm -v >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
Sean Condon0c577f62018-11-18 22:40:05 +0000164 " ng version >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
165 " ng build --extract-css --prod --preserve-symlinks" +
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000166 " --base-href /onos/ui/ --deploy-url /onos/ui/ >> $$ROOT/$(location onos-gui2-ng-build-prod.log) 2>&1 ||" +
Sean Condon87b78502018-09-17 20:53:24 +0100167 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
168 " else " +
169 " echo 'Error running \'ng build\' on \'//web/gui2:_onos-gui2-ng-build\'. \\\n" +
Sean Condon53d4e832019-10-25 12:27:54 +0100170 " See bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-build-prod.log for more details' >&2;" +
Sean Condon87b78502018-09-17 20:53:24 +0100171 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
172 " exit 1;" +
173 " fi;" +
Sean Condon95fb5742019-04-02 12:16:55 +0100174 " cp -r node_modules/gui2-fw-lib/assets src/main/webapp/dist &&" +
175 " cd src/main/webapp/dist &&" +
176 " jar Mcf $$ROOT/$(location onos-gui2-ng-build.jar) .",
Sean Condon0c577f62018-11-18 22:40:05 +0000177 message = "Angular CLI 7 build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100178)
179
180"""
181 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
Sean Condon53d4e832019-10-25 12:27:54 +0100182 See bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-lint.log or
183 bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-test.log for details of the Angular CLI output
Sean Condonf6af2a52018-08-19 10:43:24 +0100184"""
185
186genrule(
187 name = "_onos-gui2-ng-test-genrule",
188 srcs = [
189 "@nodejs//:bin/npm",
190 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100191 "@nodejs//:bin/nodejs/bin/node",
192 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100193 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
194 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
195 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonf6af2a52018-08-19 10:43:24 +0100196 ":_web_app_all",
197 ":_web_app_tests",
198 ":_angular_all",
199 ],
200 outs = [
201 "onos-gui2-ng-ver.log",
202 "onos-gui2-ng-lint.log",
203 "onos-gui2-ng-test.log",
204 ],
205 cmd = " ROOT=`pwd` &&" +
206 " export HOME=. &&" +
207 " export XDG_CONFIG_HOME=$(@D)/config &&" +
208 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100209 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
210 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100211 " mkdir -p web/gui2 &&" +
212 " cd web/gui2 &&" +
213 " jar xf ../../$(location :_angular_all) &&" +
214 " jar xf ../../$(location :_web_app_all) &&" +
215 " jar xf ../../$(location :_web_app_tests) &&" +
216 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100217 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
218 " mv package/ node_modules/gui2-fw-lib/ &&" +
219 " mkdir -p src/main/webapp/app/fw &&" +
220 " (cd src/main/webapp/app/fw &&" +
221 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100222 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700223 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100224 " node -v > ../../$(location onos-gui2-ng-ver.log) &&" +
225 " npm -v >> ../../$(location onos-gui2-ng-ver.log) &&" +
Sean Condon50855cf2018-12-23 15:37:42 +0000226 " ng version >> ../../$(location onos-gui2-ng-ver.log);" +
227 " ng lint > ../../$(location onos-gui2-ng-lint.log) 2>&1 ||" +
228 " if [ $$? -eq 0 ]; then echo 'Successfully ran lint';" +
229 " else " +
230 " echo 'Error running \'ng lint\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
Sean Condon53d4e832019-10-25 12:27:54 +0100231 " See bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-lint.log for details' >&2;" +
232 " cat ../../$(location onos-gui2-ng-lint.log) >&2 ||" +
Sean Condon50855cf2018-12-23 15:37:42 +0000233 " exit 1;" +
234 " fi;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100235 " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
236 " export CHROME_BIN=/usr/bin/chromium-browser; " +
237 " elif [ -f /opt/google/chrome/chrome ]; then " +
238 " export CHROME_BIN=/opt/google/chrome/chrome; " +
239 " else " +
240 " MSG='Warning: Step onos-gui2-ng-test skipped because \\n" +
241 " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
242 " Install Google Chrome or Chromium Browser to allow this step to run.';" +
243 " echo -e $$MSG >&2;" +
244 " echo -e $$MSG > ../../$(location onos-gui2-ng-test.log);" +
245 " exit 0;" +
246 " fi;" +
247 " ng test --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
248 " --watch=false > ../../$(location onos-gui2-ng-test.log) 2>&1 ||" +
249 " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
250 " else " +
251 " echo 'Error running \'ng test\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
Sean Condon53d4e832019-10-25 12:27:54 +0100252 " See bazel-out/k8-fastbuild/bin/web/gui2/onos-gui2-ng-test.log for more details' >&2;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100253 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
254 " exit 1;" +
255 " fi;",
Sean Condon0c577f62018-11-18 22:40:05 +0000256 message = "Angular CLI 7 lint and test",
Sean Condonf6af2a52018-08-19 10:43:24 +0100257)
258
259"""
260 Make a jar file of all the webapp files. Useful for breaking symblic links in the sandbox
261"""
262
263genrule(
264 name = "_web_app_all",
265 srcs = glob(
266 [
267 "src/main/webapp/**",
268 ],
269 exclude = [
270 "src/main/webapp/**/*.spec.ts", # Don't track tests here
271 "src/main/webapp/tests/**",
272 "src/main/webapp/node_modules/**",
273 "src/main/webapp/dist/**",
274 "src/main/webapp/doc/**",
Sean Condon87b78502018-09-17 20:53:24 +0100275 "src/main/webapp/app/fw/**",
Sean Condonf6af2a52018-08-19 10:43:24 +0100276 ],
277 ),
278 outs = ["web_app_all.jar"],
279 cmd = "cd web/gui2 &&" +
280 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
281 " jar Mcf ../../$@ src/main/webapp",
282)
283
284"""
285 Make a jar file of all the webapp test (*.spec.ts) files.
286"""
287
288genrule(
289 name = "_web_app_tests",
290 srcs = glob(
291 [
292 "src/main/webapp/**/*.spec.ts",
293 ],
294 exclude = [
295 "src/main/webapp/tests/**",
296 "src/main/webapp/node_modules/**",
297 "src/main/webapp/dist/**",
298 "src/main/webapp/doc/**",
299 ],
300 ),
301 outs = ["web_app_tests.jar"],
302 cmd = "cd web/gui2 &&" +
303 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
304 " jar Mcf ../../$@ src/main/webapp",
305)
306
307"""
308 Make a jar file of all the supporting files. Useful for breaking symblic links in the sandbox
309"""
310
311genrule(
312 name = "_angular_all",
313 srcs = [
314 ":_e2e_test_files",
315 ":_root_level_files",
316 ],
317 outs = ["angular_all.jar"],
318 cmd = " cd web/gui2 && jar Mcf ../../$@ .",
319)
320
321"""
322 Builds the java jar for the java code provided by the GUI2
323"""
324
325osgi_jar_with_tests(
326 name = "_onos-gui2-base-jar",
Sean Condon87b78502018-09-17 20:53:24 +0100327 srcs =
328 glob([
329 "src/main/java/**",
330 ]) + [
331 "//web/gui:onos-gui-java-for-gui2",
332 ],
Sean Condonb2c483c2019-01-16 20:28:55 +0000333 exclude_tests = [
334 "org.onosproject.ui.impl.AbstractUiImplTest",
335 "org.onosproject.ui.impl.topo.model.AbstractTopoModelTest",
336 ],
337 karaf_command_packages = [
338 "org.onosproject.ui.impl.cli",
339 "org.onosproject.ui.impl.topo",
340 ],
Sean Condon3c8e5582018-08-28 23:22:43 +0100341 suppress_checkstyle = True,
Sean Condonf6af2a52018-08-19 10:43:24 +0100342 test_deps = TEST_DEPS,
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000343 web_context = "/onos/ui",
Sean Condonf6af2a52018-08-19 10:43:24 +0100344 deps = COMPILE_DEPS,
345)
346
347"""
348 Builds the tar ball for the ONOS GUI2
349"""
350
351genrule(
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000352 name = "onos-web-gui2",
Sean Condonf6af2a52018-08-19 10:43:24 +0100353 srcs = [
354 ":_onos-gui2-ng-build",
355 ":_onos-gui2-base-jar",
356 ":_web_inf_classes_files",
Sean Condonb2c483c2019-01-16 20:28:55 +0000357 "//web/gui:onos-gui-lion-for-gui2",
Sean Condon0d064ec2019-02-04 21:53:53 +0000358 "//web/gui:onos-gui-data-for-gui2",
Sean Condon3c8e5582018-08-28 23:22:43 +0100359 "src/main/webapp/WEB-INF/web.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100360 ],
361 outs = ["onos-gui2.jar"],
362 cmd = " ROOT=`pwd` &&" +
363 " mkdir -p web/gui2/WEB-INF/classes &&" +
364 " cd web/gui2 &&" +
365 " BUILD_FILES=($(locations :_onos-gui2-ng-build)) &&" + # An array of filenames - sorted by time created
366 " for i in $(locations :_web_inf_classes_files); do cp $$ROOT/$$i ./WEB-INF/classes/; done &&" +
367 " (cd WEB-INF/classes && jar xf $$ROOT/$${BUILD_FILES[1]}) &&" +
368 " jar xf $$ROOT/$(location :_onos-gui2-base-jar) &&" +
Sean Condonb2c483c2019-01-16 20:28:55 +0000369 " unzip -q $$ROOT/$(location //web/gui:onos-gui-lion-for-gui2) web/gui/src/main/resources/**/* &&" +
370 " mv web/gui/src/main/resources/org/onosproject/ui/lion* WEB-INF/classes/org/onosproject/ui/ &&" +
371 " mv web/gui/src/main/resources/core WEB-INF/classes/ &&" +
Sean Condon0d064ec2019-02-04 21:53:53 +0000372 " unzip -q $$ROOT/$(location //web/gui:onos-gui-data-for-gui2) web/gui/src/main/webapp/data/**/* &&" +
373 " mv web/gui/src/main/webapp/data WEB-INF/classes/ &&" +
Sean Condon95fb5742019-04-02 12:16:55 +0100374 " find . -type f -exec touch -t 201903200000 {} \; &&" +
Sean Condonb2c483c2019-01-16 20:28:55 +0000375 " jar cmf META-INF/MANIFEST.MF $$ROOT/$@ WEB-INF/web.xml WEB-INF/classes OSGI-INF/*.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100376 output_to_bindir = 1,
377 visibility = ["//visibility:public"],
378)
379
380"""
381 Wrap the genrule for testing in a test
382"""
383
384sh_test(
385 name = "onos-gui2-ng-tests",
386 size = "small",
387 srcs = [
388 ":ng-test.sh",
389 ],
390 data = [
391 ":_onos-gui2-ng-test-genrule",
392 ],
393 deps = [
394 "@bazel_tools//tools/bash/runfiles",
395 ],
396)
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000397
398onos_app(
399 category = "Graphical User Interface",
400 description = "ONOS GUI2 - a reengineered version of the original ONOS GUI " +
401 "based on the latest Angular framework components",
402 title = "ONOS GUI2",
403 url = "http://onosproject.org",
404)